/*=========================================================================
*
*  Copyright NumFOCUS
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*         http://www.apache.org/licenses/LICENSE-2.0.txt
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*=========================================================================*/
#ifndef sitkBoundedReciprocalImageFilter_h
#define sitkBoundedReciprocalImageFilter_h

/*
 * WARNING: DO NOT EDIT THIS FILE!
 * THIS FILE IS AUTOMATICALLY GENERATED BY THE SIMPLEITK BUILD PROCESS.
 * Please look at sitkImageFilterTemplate.h.in to make changes.
 */

#include <memory>

#include "sitkBasicFilters.h"
#include "sitkImageFilter.h"

namespace itk::simple {

    /**\class BoundedReciprocalImageFilter
\brief Computes 1/(1+x) for each pixel in the image.

The filter expects both the input and output images to have the same number of dimensions, and both of a scalar image type.
\sa itk::simple::BoundedReciprocal for the procedural interface
\sa itk::BoundedReciprocalImageFilter for the Doxygen on the original ITK class.
     */
    class SITKBasicFilters_EXPORT BoundedReciprocalImageFilter : public ImageFilter {
    public:
      using Self = BoundedReciprocalImageFilter;

      /** Destructor */
      virtual ~BoundedReciprocalImageFilter();

      /** Default Constructor that takes no arguments and initializes
       * default parameters */
      BoundedReciprocalImageFilter();

      /** Define the pixels types supported by this filter */
      using PixelIDTypeList = BasicPixelIDTypeList;


      /** Name of this class */
      std::string GetName() const { return std::string ("BoundedReciprocalImageFilter"); }

      /** Print ourselves out */
      std::string ToString() const;


      /** Execute the filter on the input image */
#ifndef SWIG
      Image Execute ( Image&& image1 );
#endif
      Image Execute ( const Image& image1 );

    private:

      /** Setup for member function dispatching */

      using MemberFunctionType = Image (Self::*)( const Image& image1 );
      template <class TImageType> Image ExecuteInternal ( const Image& image1 );
      /** Dispatched methods which calls ExecuteInternal on each component */
      template <class TImageType> Image ExecuteInternalVectorImage ( const Image& image );

      friend struct detail::MemberFunctionAddressor<MemberFunctionType>;
      friend struct detail::ExecuteInternalVectorImageAddressor<MemberFunctionType>;
      std::unique_ptr<detail::MemberFunctionFactory<MemberFunctionType> > m_MemberFactory;



      bool m_InPlace{false};
    };

    /**\
     * \brief Computes 1/(1+x) for each pixel in the image.
     *
     * This function directly calls the execute method of BoundedReciprocalImageFilter
     * in order to support a procedural API
     *
     * \sa itk::simple::BoundedReciprocalImageFilter for the object oriented interface
     * @{
     */
#ifndef SWIG
     SITKBasicFilters_EXPORT Image BoundedReciprocal ( Image&& image1 );
#endif
     SITKBasicFilters_EXPORT Image BoundedReciprocal ( const Image& image1 );

     /** @} */
}
#endif
